package cn.pugle.mianshi.thread1To10;

import java.util.concurrent.Semaphore;

import static cn.pugle.mianshi.thread1To10.Constant.MAX;

/**
 * <p> Created by tzp on 2017/9/6.
 */
@SuppressWarnings({"Duplicates", "AlibabaRemoveCommentedCode"})
public class PrintToTen6a implements Runnable {
    private int count = 1;
    private Semaphore semaphore1 = new Semaphore(1);
    private Semaphore semaphore2 = new Semaphore(1);

    @Override
    public void run() {
        System.out.println(Thread.currentThread() + " Hello World");

        Thread thread1 = new Thread(() -> {
            while (count <= MAX) {
                try {
                    semaphore1.acquire();
                    if (count % 2 == 0 && count <= MAX) {
                        System.out.println(Thread.currentThread() + " " + count++);
                    }
                    semaphore2.release();
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
            }
        });
        thread1.start();

        Thread thread2 = new Thread(() -> {
            while (count <= MAX) {
                try {
                    semaphore2.acquire();
                    if (count % 2 == 1 && count <= MAX) {
                        System.out.println(Thread.currentThread() + " " + count++);
                    }
                    semaphore1.release();
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
            }
        });
        thread2.start();

        try {
            thread1.join();
            thread2.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
        new PrintToTen6a().run();
    }
}
